
//This file is part of OPeNDAP-Access Tool
//Author: Viral Jain (viral_jain@hotmail.com)
//
//Copyright (c) 2004, Viral Jain
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//You can contact Viral Jain at 4270 Williamsburg Dr, Apt#G, Harrisburg, PA - 17109
//

// DPage1.cpp : implementation file
//

#include "stdafx.h"
#include "test1.h"
#include "DPage1.h"

//////////My Addition//////////
#include <iostream>

#include ".\dods\Connect.h"
#include ".\dods\Error.h"
#include "DWizard.h"

//using namespace std;
//////My Addition Ends/////////

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDPage1 property page

IMPLEMENT_DYNCREATE(CDPage1, CPropertyPage)

CDPage1::CDPage1() : CPropertyPage(CDPage1::IDD)
{
	//{{AFX_DATA_INIT(CDPage1)
	m_EDIUrlV = _T("");
	m_EDTBNameV = _T("");
	m_EDDBNameV = _T("");
	//}}AFX_DATA_INIT
}

CDPage1::~CDPage1()
{
}

void CDPage1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDPage1)
	DDX_Control(pDX, IDC_STATIC_P1URL, m_SP1URLC);
	DDX_Control(pDX, IDC_STATIC_P1TN, m_SP1TNC);
	DDX_Control(pDX, IDC_STATIC_P1T2, m_SP1T2C);
	DDX_Control(pDX, IDC_STATIC_P1T1, m_SP1T1C);
	DDX_Control(pDX, IDC_STATIC_P1DN, m_SP1DNC);
	DDX_Text(pDX, IDC_EDIT_DIMPURL, m_EDIUrlV);
	DDX_Text(pDX, IDC_EDIT_DTABLENAME, m_EDTBNameV);
	DDX_Text(pDX, IDC_EDIT_DDBNAME, m_EDDBNameV);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CDPage1)
	ON_WM_CTLCOLOR()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDPage1 message handlers

BOOL CDPage1::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CPropertySheet *p = (CPropertySheet *)this->GetParent();
	p->SetWizardButtons(PSWIZB_NEXT);

	return CPropertyPage::OnSetActive();
}

BOOL CDPage1::OnKillActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	UpdateData(TRUE);

	if( (m_EDIUrlV == "") || (m_EDDBNameV == "") ||
		(m_EDTBNameV == "") )
	{
		MessageBox("All Fields are necessary! Please enter value "
					"in ALL the Fields.", "Error", MB_OK|MB_ICONERROR);
		return 0;
	}

	CDWizard *p = (CDWizard *)this->GetParent();
	p->m_ImpURL = m_EDIUrlV;
	p->m_DBName = m_EDDBNameV;
	p->m_TBName = m_EDTBNameV;

	string url;
	url = (LPCTSTR)p->m_ImpURL;

	p->m_DCon = new Connect(url, false, false);

	bool flag = false;
	try
	{
		flag = p->m_DCon->request_das();
		flag = p->m_DCon->request_dds();

		p->m_das = new DAS(p->m_DCon->das());
		p->m_dds = new DDS(p->m_DCon->dds());
	}
	catch(Error e)
	{
		MessageBox(e.error_message().c_str(),"Error",MB_OK);
		MessageBox("Could not connect to the dataset.\n"
			"Please check the link and make sure the server is alive.",
			"Error",MB_OK|MB_ICONERROR);
		return 0;
	}

	if(!flag)
	{
		MessageBox("Some Problem","Error",MB_OK);
	}

	return CPropertyPage::OnKillActive();
}
HBRUSH CDPage1::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CDPage1::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	// Do not call CPropertyPage::OnPaint() for painting messages
}
