//This file is part of OPeNDAP-Access Tool
//Author: Viral Jain (viral_jain@hotmail.com)
//
//Copyright (c) 2004, Viral Jain
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//You can contact Viral Jain at 4270 Williamsburg Dr, Apt#G, Harrisburg, PA - 17109
//

// DPage2.cpp : implementation file
//


#include "stdafx.h"
#include "test1.h"
#include "DPage2.h"

//////////My Addition/////////////////
#include <afxtempl.h>
#include <iostream>
#include <fstream>
#include "DWizard.h"
#include ".\dods\BaseType.h"
#include ".\dods\Pix.h"
#include <limits>
//#include <strstrea.h>

//using namespace std;
////////My Addition Ends/////////////


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDPage2 property page

IMPLEMENT_DYNCREATE(CDPage2, CPropertyPage)

CDPage2::CDPage2() : CPropertyPage(CDPage2::IDD)
{
	//{{AFX_DATA_INIT(CDPage2)
	m_EDCEV = _T("");
	m_EDDASV = _T("");
	m_EDDDSV = _T("");
	m_EDLCEV = _T("");
	m_TEPTextV = _T("");
	//}}AFX_DATA_INIT
}

CDPage2::~CDPage2()
{
}

void CDPage2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDPage2)
	DDX_Control(pDX, IDC_EDIT_PRGTEXT, m_TEPTextC);
	DDX_Control(pDX, IDC_EDIT_DLEARNCE, m_TEDLCEC);
	DDX_Control(pDX, IDC_EDIT_DDDS, m_TEDDDSC);
	DDX_Control(pDX, IDC_EDIT_DDAS, m_TEDDASC);
	DDX_Control(pDX, IDC_EDIT_DCE, m_TEDCEC);
	DDX_Control(pDX, IDC_PROGRESS_INGEST, m_PCIngestC);
	DDX_Text(pDX, IDC_EDIT_DCE, m_EDCEV);
	DDX_Text(pDX, IDC_EDIT_DDAS, m_EDDASV);
	DDX_Text(pDX, IDC_EDIT_DDDS, m_EDDDSV);
	DDX_Text(pDX, IDC_EDIT_DLEARNCE, m_EDLCEV);
	DDX_Text(pDX, IDC_EDIT_PRGTEXT, m_TEPTextV);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDPage2, CPropertyPage)
	//{{AFX_MSG_MAP(CDPage2)
	ON_BN_CLICKED(IDC_BUTTON_DSTIMP, OnButtonDstimp)
	ON_WM_CTLCOLOR()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDPage2 message handlers

BOOL CDPage2::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	CDWizard *p = (CDWizard *)this->GetParent();
	p->SetWizardButtons(PSWIZB_BACK | PSWIZB_FINISH);
	
	m_EDLCEV = "http://www.unidata.ucar.edu/packages/dods/user/guide-html/guide_33.html";

	char buf[16384];
	int i;

	ofstream fs1("__DTEMP__.txt");
	p->m_das->print(fs1);
	fs1.flush();
	fs1.close();

	CFile fp;
	fp.Open("__DTEMP__.txt",CFile::modeRead);
	i = fp.Read(buf, 16384);
	buf[i] = '\0';
	m_EDDASV = (buf);
	fp.Close();
	
	ofstream fs2("__DTEMP__.txt");
	p->m_dds->print(fs2);
	fs2.flush();
	fs2.close();

	fp.Open("__DTEMP__.txt",CFile::modeRead);
	i = fp.Read(buf, 16384);
	buf[i] = '\0';
	m_EDDDSV = (buf);
	fp.Close();

	DeleteFile("__DTEMP__.txt");

	UpdateData(FALSE);

	m_TEPTextC.SetWindowText("Welcome!");
	m_TEPTextC.SendMessage( WM_PAINT, 0, 0);

	return CPropertyPage::OnSetActive();
}

void CDPage2::OnButtonDstimp() 
{
	// TODO: Add your control notification handler code here
	CDWizard *pParent = (CDWizard *)this->GetParent();

	UpdateData(TRUE);
	
	DDS *data;

	m_TEPTextC.SetWindowText("Getting Data From The Server. This could take Several Minutes....");
	m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
	m_PCIngestC.SetPos(50);

	try
	{
		data = pParent->m_DCon->request_data((LPCTSTR)m_EDCEV);
	}
	catch(Error e)
	{
		CString buf;
		buf.Format("Incorrect Constraint Expression/Corrupted Data/Network Failure. Following Error Occured...\n%s",
				e.get_error_message().c_str());
		MessageBox(buf,"Error",MB_OK);

		m_TEPTextC.SetWindowText("Please retry!");
		m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
		m_PCIngestC.SetPos(0);

		return;
	}

	m_TEPTextC.SetWindowText("Processing data...");
	m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
	m_PCIngestC.SetPos(100);

	CArray<BaseType*, BaseType*> myvars;

	BaseType *pBT = NULL;

	DDS::Vars_iter myitr;
	int count,i;

	myvars.SetSize(100,10);
	count = -1;
	for(myitr=data->var_begin();myitr!=data->var_end();myitr++)
	{
		try
		{
			pBT = *(myitr);
			count++;
			myvars.SetAt(count, pBT);
		}
		catch(Error err)
		{
			MessageBox(err.get_error_message().c_str(), "Strange Error!",MB_OK);
			return;
		}
	}
	try
	{
		pParent->m_DbCon.Create((LPCTSTR)pParent->m_DBName);
	}
	catch(CDaoException DaoE)
	{
		char buf[512];
		DaoE.GetErrorMessage(buf, 1);
		MessageBox(buf,"Error!", MB_OK);
		return;
	}

	CString query, tquery, ts, tdisp;

	query = ("CREATE TABLE ") + pParent->m_TBName + " ( " + 
			"_NAME_ VARCHAR(128), _TYPE_ VARCHAR(32)," +
			"_VALUE_ VARCHAR(64), _TABLE_ VARCHAR(128)," +
			"_VARIABLES_ MEMO );";

	Type t;

	try
	{
		pParent->m_DbCon.Execute((LPCTSTR)query);
	}
	catch(CDaoException e)
	{
		char buf[512];
		e.GetErrorMessage(buf, 512);
		MessageBox(buf,"Error:Could not Ingest Data!",MB_OK);
		return;
	}

	tquery = "INSERT INTO " + pParent->m_TBName + " VALUES ( ";

	for(i=0;i<=count;i++)
	{
		pBT = myvars.GetAt(i);
		query = query + pBT->name().c_str();
		t = pBT->type();
		switch(t)
		{
			case dods_null_c:
			case dods_byte_c:
			case dods_int16_c:
			case dods_uint16_c:
			case dods_int32_c:
			case dods_uint32_c:
			case dods_float32_c:
			case dods_float64_c:
			case dods_str_c:
			case dods_url_c:
				{
					CString tq, tval, tdt;
					GetDataInfo(pBT, tval, tdt, TRUE);
					tq = tquery + "'" + pBT->name().c_str() + "','" + tdt +
						 "','" + tval + "',NULL,NULL);";

					tdisp.Format("Ingesting %s ( %s )...",
									pBT->name().c_str(),tdt);
					m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
					m_TEPTextC.SendMessage( WM_PAINT, 0, 0);

					try
					{
						pParent->m_DbCon.Execute((LPCTSTR)tq);
					}
					catch(CDaoException e)
					{
						char buf[512];
						e.GetErrorMessage(buf, 512);
						MessageBox(buf,"Error:Could not Ingest Data!",MB_OK);
						break;
					}

					tdisp.Format("Ingesting %s...Done. ",
									pBT->name().c_str());
					m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
					m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
				}
				break;
			case dods_array_c:
				{
					Array *arrv;

					int dimcount = -1;

					CArray<int, int> dimsize;
					CArray<int, int> curpos;

					dimsize.SetSize(10,10);
					curpos.SetSize(10,10);

					arrv = ((Array *)pBT);
					if(arrv->type() == dods_array_c)
					{
						int dc = arrv->dimensions();
						Array::Dim_iter dimi;
						BaseType *tbt;
						string dname;
						BOOL flag = TRUE;

						CString tq, tval, tdt;

						tq = ("CREATE TABLE _DODS_");
						tq = tq + pBT->name().c_str() + (" ( ");

						ts = tquery + "'" + pBT->name().c_str() + 
							  "','dods_array',NULL,'_DODS_" +
							  pBT->name().c_str() + "','";

						int ai = 0;
						for(dimi = arrv->dim_begin();
								dimi != arrv->dim_end(); dimi++,ai++)
						{
							dname = arrv->dimension_name(dimi);
							dimsize.SetAt(ai, arrv->dimension_size(dimi, true));
							curpos.SetAt(ai, 0);
							tq = tq + dname.c_str() + " INTEGER,";
							ts = ts + dname.c_str() + (",");
						}
						ts = ts + "_VALUE_');";
						dimcount = ai-1;
						if(flag)
						{
							tbt = arrv->var(0);
							GetDataInfo( tbt, tval, tdt, FALSE);
							tq = tq + "_VALUE_ " + tdt + ");";

							tdisp.Format("Creating table _DODS_%s...",
											pBT->name().c_str());
							m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
							m_TEPTextC.SendMessage( WM_PAINT, 0, 0);

							m_PCIngestC.SetPos(10);

							try
							{
								pParent->m_DbCon.Execute((LPCTSTR)tq);
								pParent->m_DbCon.Execute((LPCTSTR)ts);
							}
							catch(CDaoException e)
							{
								flag = FALSE;
								char buf[512];
								e.GetErrorMessage(buf, 512);
								MessageBox(buf,"Error:Could not Create Table!",MB_OK);
							}
							m_PCIngestC.SetPos(100);
						}
						if(flag)
						{ 
							int ub = dimcount;
							int arrcount = dimsize[ub];
							int pos,pcount,tcount,k, disp1,disp2;
							BaseType *tbt;
							BOOL carryf;
							CString tq2;
							for(;flag;)
							{
								tq = ("INSERT INTO _DODS_");
								tq = tq + pBT->name().c_str() + " VALUES (";
								pcount = 0;
								disp2 = 1;
								for(ai=0;ai<=ub;ai++)
								{
									disp2 = disp2 * dimsize[ai];
								}
								for(ai=0;ai<ub;ai++)
								{
									tcount = curpos[ai];
									for(k=ai+1;k<=ub;k++)
									{
										tcount = tcount*dimsize[k];
									}
									pcount = pcount + tcount;
									tval.Format("%d,", curpos[ai]);
									tq = tq + tval;
								}
								for(ai=0; ai < arrcount; ai++)
								{
									tval.Format("%d,", curpos[ub]);
									tq2 = tq + tval;

									tbt = arrv->var(pcount+ai);
									GetDataInfo(tbt, tval, tdt, TRUE);
									tq2 = tq2 + tval + ");";

									disp1 = pcount + ai;

									if((disp1%20)==0)
									{
										tdisp.Format("Ingesting into _DODS_%s Record: %d / %d ...",
											         pBT->name().c_str(), disp1, disp2);
										m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
										m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
										m_PCIngestC.SetPos((disp1*100)/disp2);
									}

									try
									{
										pParent->m_DbCon.Execute((LPCTSTR)tq2);
									}
									catch(CDaoException e)
									{
										char buf[512];
										flag = FALSE;
										e.GetErrorMessage(buf, 512);
										MessageBox(buf,"Error:Could not Ingest Data!",MB_OK);
										break;
									}
									curpos.SetAt(ub, (curpos[ub] + 1));
								}
								curpos.SetAt(ub, (curpos[ub] - 1));
								carryf = TRUE;
								for(ai=ub;(ai>-1)&&carryf;ai--)
								{
									pos = curpos[ai];

									if(pos == (dimsize[ai]-1))
									{
										if(ai==0)
										{
											carryf = FALSE;
											flag = FALSE;
											continue;
										}
										curpos.SetAt(ai, 0);
									}
									else
									{
										pos++;
										curpos.SetAt(ai,pos);
										carryf = FALSE;
									}
								}
							}
						}
					}
				}
				break;
			case dods_list_c:
				{
					List *listv;
					listv = ((List *)pBT);
					if(listv->type() == dods_list_c)
					{
						BaseType *tbt;
						BOOL flag = TRUE;

						CString tq, tval, tdt;

						tq = ("CREATE TABLE _DODS_");
						tq = tq + pBT->name().c_str() + (" ( ");
						tq = tq + "_INDEX_ INTEGER, _VALUE_ ";

						tbt = listv->var(0);
						if(tbt == NULL)
						{
							break;
						}
						GetDataInfo(tbt, tval, tdt, FALSE);

						tq = tq + tdt + (");");

						ts.Format("Creating Table _DODS_%s...",pBT->name().c_str());
						m_TEPTextC.SetWindowText(ts);
						m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
						m_PCIngestC.SetPos(0);

						ts = tquery + "'" + pBT->name().c_str() + 
								"','dods_list',NULL,'_DODS_" + pBT->name().c_str() + 
								"','_INDEX_,_VALUE_');";
							 

						try
						{
							pParent->m_DbCon.Execute((LPCTSTR)tq);
							pParent->m_DbCon.Execute((LPCTSTR)ts);
						}
						catch(CDaoException e)
						{
							flag = FALSE;
							char buf[512];
							e.GetErrorMessage(buf, 512);
							MessageBox(buf,"Error:Could not Create Table!",MB_OK);
						}

						if(flag)
						{
							m_PCIngestC.SetPos(100);
							int curpos;
							int llen = listv->length();
									
							CString tq2;
							tq = ("INSERT INTO _DODS_");
							tq = tq + pBT->name().c_str() + " VALUES (";

							for(curpos=0; (curpos<llen)&&flag; curpos++)
							{
								tq2.Format("%d,",curpos);
								tbt = listv->var(curpos);
								GetDataInfo(tbt, tval, tdt, TRUE);
								tq2 = tq2 + tval + ");";

								if((curpos%20)==0)
								{
									tdisp.Format("Ingesting into _DODS_%s Record: %d / %d",
											     pBT->name().c_str(), curpos, llen);
									m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
									m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
									m_PCIngestC.SetPos((curpos*100)/llen);
								}

								try
								{
									pParent->m_DbCon.Execute((LPCTSTR)tq2);
								}
								catch(CDaoException e)
								{
									char buf[512];
									flag = FALSE;
									e.GetErrorMessage(buf, 512);
									MessageBox(buf,"Error:Could not Ingest Data!",MB_OK);
									break;
								}
							}
						}
					}
				}
				break;
			case dods_structure_c:
				ts.Format("\"Structure\" type encountered.\n"
							"It is not supported in this version."
							"\n'%s' field will not be imported."
							"\nPlease contact Viral at viral_jain@hotmail.com for updates",
							pBT->name().c_str());
				MessageBox(ts,"Format Not Supported!", MB_OK);
				break;
			case dods_sequence_c:
				{
					Sequence *pSeq;

					pSeq = (Sequence *)pBT;
					if(pSeq->is_linear() == false)
					{
						ts.Format("'Sequence' found to be non-linear.\n"
									"It is not supported in this version.\n"
									"'%s' will not be imported.\n"
									"Please contact Viral at viral_jain@hotmail.com for updates.",pSeq->name());
						MessageBox(ts,"Unsupported format!",MB_OK);
					}
					else
					{
						CString tq;
						CString dbstr, dblist, dbquery, lname;
						dbquery = ("");
						dbstr = ("");
						dblist = ("");
						lname = ("");

						tq = tquery + "'" + pSeq->name().c_str() +
							"','dods_sequence',NULL,'_DODS_" + 
							pSeq->name().c_str() + "','";

						BOOL ret = TraverseSeq(pSeq, query, lname,
									dbstr, dblist, FALSE);

						if(!ret)
						{
							ts.Format("Unsupported Data Sturcture / Corrupted Data."
									  "\n'%s' will not be imported"
									  "\nPlease contact Viral at viral_jain@hotmail.com for updates",
									  pSeq->name().c_str());
							MessageBox(ts, "Error!", MB_OK);
							break;
						}

						tq = tq + dblist + "');";
						ts = "CREATE TABLE _DODS_";
						ts = ts + pSeq->name().c_str() + " (" + 
							dbstr + ");";

						tdisp.Format("Creating Table _DODS_%s...",
									 pBT->name().c_str());
						m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
						m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
						m_PCIngestC.SetPos(10);

						try
						{
							pParent->m_DbCon.Execute((LPCTSTR)tq);
							pParent->m_DbCon.Execute((LPCTSTR)ts);
						}
						catch(CDaoException e)
						{
							char buf[512];
							e.GetErrorMessage(buf, 512);
							MessageBox(buf,"Error:Could not Create Table!",MB_OK);
							break;
						}

						dbquery = "INSERT INTO _DODS_";
						dbquery = dbquery + pSeq->name().c_str() + 
									" VALUES (";
						
						ret = TraverseSeq(pSeq, dbquery, lname, dbstr, dblist, TRUE);

						if(!ret)
						{
							MessageBox("Data could not be imported properly!\n"
								       "Please contact Viral at viral_jain@hotmail.com with dataset URL and Constraint Expression used.",
									   "Error!", MB_OK);
						}
					}
				}
				break;
			case dods_grid_c:
				{
					BaseType *arrv;

					int dimcount = -1;

					CArray<int, int> dimsize;
					CArray<int, int> curpos;
					CArray<Array *, Array *> mapv;

					dimsize.SetSize(10,10);
					curpos.SetSize(10,10);
					mapv.SetSize(10,10);

					arrv = ((Grid *)pBT)->array_var();
					if(arrv->type() == dods_array_c)
					{
						int dc = ((Array *)arrv)->dimensions();
						Array::Dim_iter dimi;
						Grid::Map_iter mapi;
						BaseType *tbt;
						string dname;
						BOOL flag = TRUE;

						CString tq, tval, tdt;

						tq = ("CREATE TABLE _DODS_");
						tq = tq + pBT->name().c_str() + (" ( ");

						ts = tquery + "'" + pBT->name().c_str() + 
							  "','dods_grid',NULL,'_DODS_" +
							  pBT->name().c_str() + "','";

						int ai = 0;
						for(dimi = ((Array *)arrv)->dim_begin();
								dimi != ((Array *)arrv)->dim_end(); dimi++,ai++)
						{
							dname = ((Array *)arrv)->dimension_name(dimi);
							dimsize.SetAt(ai, ((Array *)arrv)->dimension_size(dimi, true));
							curpos.SetAt(ai, 0);
							for(mapi=((Grid *)pBT)->map_begin();
									mapi != ((Grid *)pBT)->map_end();
										mapi++)
							{
								tbt = *mapi;
								if(tbt->type() != dods_array_c)
								{
									MessageBox("Corrupted Data! Result will be unexpected! Please retry","Internal Error", MB_OK);
									dimi = ((Array *)arrv)->dim_end();
									flag = FALSE;
									break;
								}
								if(tbt->name() == dname)
								{
									mapv.SetAt(ai, (Array *)tbt);
									tbt = ((Array *)tbt)->var(0);
									GetDataInfo( tbt, tval, tdt, FALSE);
									tq = tq + tbt->name().c_str()+
										" " + tdt + ",";

									ts = ts + tbt->name().c_str() + (",");

									break;
								}
							}
						}
						dimcount = ai-1;
						if(flag)
						{
							tbt = ((Array *)arrv)->var(0);
							GetDataInfo( tbt, tval, tdt, FALSE);
							tq = tq + arrv->name().c_str() + " " + tdt + ");";

							ts = ts + arrv->name().c_str() + "');";

							tdisp.Format("Creating table _DODS_%s...",
											pBT->name().c_str());
							m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
							m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
							m_PCIngestC.SetPos(10);

							try
							{
								pParent->m_DbCon.Execute((LPCTSTR)tq);
								pParent->m_DbCon.Execute((LPCTSTR)ts);
							}
							catch(CDaoException e)
							{
								flag = FALSE;
								char buf[512];
								e.GetErrorMessage(buf, 512);
								MessageBox(buf,"Error:Could not Create Table!",MB_OK);
							}
							m_PCIngestC.SetPos(100);
						}
						if(flag)
						{
							int ub = dimcount;
							int arrcount = dimsize[ub];
							int pos,pcount,tcount,k, disp1,disp2;
							BaseType *tbt;
							BOOL carryf;
							CString tq2;
							for(;flag;)
							{
								tq = ("INSERT INTO _DODS_");
								tq = tq + pBT->name().c_str() + " VALUES (";
								pcount = 0;
								disp2 = 1;
								for(ai=0;ai<=ub;ai++)
								{
									disp2 = disp2 * dimsize[ai];
								}
								for(ai=0;ai<ub;ai++)
								{
									tcount = curpos[ai];
									for(k=ai+1;k<=ub;k++)
									{
										tcount = tcount*dimsize[k];
									}
									pcount = pcount + tcount;
									tbt = ((Array *)(mapv[ai]))->var(curpos[ai]);
									GetDataInfo(tbt, tval, tdt, TRUE);
									tq = tq + tval + (",");
								}
								for(ai=0; ai < arrcount; ai++)
								{
									tbt = ((Array *)(mapv[ub]))->var(ai);
									GetDataInfo(tbt, tval, tdt, TRUE);
									tq2 = tq + tval + (",");

									tbt = ((Array *)arrv)->var(pcount+ai);
									GetDataInfo(tbt, tval, tdt, TRUE);
									tq2 = tq2 + tval + ");";

									char buf[1024];
									strcpy(buf, (LPCTSTR)tq2);

									disp1 = pcount + ai;
									if((disp1%20)==0)
									{
										tdisp.Format("Ingesting into _DODS_%s Record: %d / %d",
											         pBT->name().c_str(), disp1, disp2);
										m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
										m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
										m_PCIngestC.SetPos((disp1*100)/disp2);
									}

									try
									{
										pParent->m_DbCon.Execute((LPCTSTR)tq2);
									}
									catch(CDaoException e)
									{
										char buf[512];
										flag = FALSE;
										e.GetErrorMessage(buf, 512);
										MessageBox(buf,"Error:Could not Ingest Data!",MB_OK);
										break;
									}
									curpos.SetAt(ub, (curpos[ub] + 1));
								}
								curpos.SetAt(ub, (curpos[ub] - 1));
								carryf = TRUE;
								for(ai=ub;(ai>-1)&&carryf;ai--)
								{
									pos = curpos[ai];

									if(pos == (dimsize[ai]-1))
									{
										if(ai==0)
										{
											carryf = FALSE;
											flag = FALSE;
											continue;
										}
										curpos.SetAt(ai, 0);
									}
									else
									{
										pos++;
										curpos.SetAt(ai,pos);
										carryf = FALSE;
									}
								}
							}
						}
					}
					else
					{
						MessageBox("DATA Corrupted!! Please retry!", "Internal Error!", MB_OK);
					}
				}
				break;
			default:
				MessageBox("Unknown Type!","Internal Error",MB_OK);
				break;
		}
	}

	try
	{
		pParent->m_DbCon.Close();
	}
	catch(CDaoException e)
	{
		MessageBox("Could not properly close the database!","Error",MB_OK);
	}

	m_TEPTextC.SetWindowText("DODS DATA IMPORT COMPLETED SUCCESSFULLY!");
	m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
	m_PCIngestC.SetPos(100);
}

BOOL CDPage2::GetDataInfo(BaseType *pData, CString &val, CString &dbtype, BOOL getval)
{
	dods_byte *dbv;
	dods_int16 *di16v;
	dods_uint16 *dui16v;
	dods_int32 *di32v;
	dods_uint32 *dui32v;
	dods_float32 *df32v;
	dods_float64 *df64v;
	string *suv;

	dbv = new dods_byte;
	di16v = new dods_int16;
	dui16v = new dods_uint16;
	di32v = new dods_int32;
	dui32v = new dods_uint32;
	df32v = new dods_float32;
	df64v = new dods_float64;
	suv = NULL;

	Type bt = pData->type();

	BOOL ret = TRUE;

	switch(bt)
	{
		case dods_null_c:
			val = ("NULL");
			dbtype = ("VARCHAR(8)");
			break;
		case dods_byte_c:
			if(getval)
			{
				((Byte *)pData)->buf2val((void **)&dbv);
				val.Format("%d",*dbv);
			}
			dbtype = ("NUMBER");
			break;
		case dods_int16_c:
			if(getval)
			{
				((Int16 *)pData)->buf2val((void **)&di16v);
				val.Format("%d",*di16v);
			}
			dbtype = ("NUMBER");
			break;
		case dods_uint16_c:
			if(getval)
			{
				((UInt16 *)pData)->buf2val((void **)&dui16v);
				val.Format("%d", *dui16v);
			}
			dbtype = ("NUMBER");
			break;
		case dods_int32_c:
			if(getval)
			{
				((Int32 *)pData)->buf2val((void **)&di32v);
				val.Format("%d",*di32v);
			}
			dbtype = ("NUMBER");
			break;
		case dods_uint32_c:
			if(getval)
			{
				((UInt32 *)pData)->buf2val((void **)&dui32v);
				val.Format("%d",*dui32v);
			}
			dbtype = ("NUMBER");
			break;
		case dods_float32_c:
			if(getval)
			{
				((Float32 *)pData)->buf2val((void **)&df32v);
				if( _isnan(*df32v))
				{
					val = ("NULL");
				}
				else
				{
					val.Format("%f",*df32v);
				}
			}
			dbtype = ("DOUBLE");
			break;
		case dods_float64_c:
			if(getval)
			{
				((Float64 *)pData)->buf2val((void **)&df64v);
				if( _isnan(*df64v))
				{
					val = ("NULL");
				}
				else
				{
					val.Format("%f",*df64v);
				}
			}
			dbtype = ("DOUBLE");
			break;
		case dods_str_c:
			if(getval)
			{
				((Str *)pData)->buf2val((void **)&suv);
				val.Format("'%s'",suv->c_str());
			}
			dbtype = ("MEMO");
			break;
		case dods_url_c:
			if(getval)
			{
				((Url *)pData)->buf2val((void **)&suv);
				val.Format("'%s'",suv->c_str());
			}
			dbtype = ("MEMO");
			break;
		default:
			MessageBox("Unexpected Data Type! May be Corrupt Data!\nPlease retry.",
						"Internal Error!",
						MB_OK);
			ret = FALSE;
			break;
	}

	delete dbv;
	delete di16v;
	delete dui16v;
	delete di32v;
	delete dui32v;
	delete df32v;
	delete df64v;
	if(suv != NULL)
	{
		delete suv;
	}

	return ret;
}

HBRUSH CDPage2::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CDPage2::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	// Do not call CPropertyPage::OnPaint() for painting messages
}

BOOL CDPage2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CDPage2::TraverseSeq(Sequence *pSeq, CString &query, CString &lname, CString &dbname, CString &list, BOOL value)
{
	int nRow = pSeq->number_of_rows();

	int count;
	Sequence *pChild = NULL;
	BaseType *pBT = NULL;
	BaseTypeRow *pBTR = NULL;
	BOOL isSeqC = FALSE, flag = TRUE, valueflag = TRUE;
	std::vector<BaseType *>::iterator iter;
	CString tdisp, tquery;


	for(count = 0; (count< nRow) && flag && valueflag; count++)
	{
		tquery = query;
		pBTR = pSeq->row_value( count );

		for(iter = pBTR->begin(); (iter!= pBTR->end()) && flag;iter++)
		{
			pBT = *(iter);
			Type t = pBT->type();
			switch(t)
			{
				case dods_sequence_c:
					if(isSeqC)
					{
						flag = FALSE;
						break;
					}
					isSeqC = TRUE;
					pChild = (Sequence *)pBT;
					break;
				case dods_structure_c:
					MessageBox("'Structure' type encountered\nIt is not supported in this version.",
								"Function not supported!", MB_OK);
					flag = FALSE;
					break;
				case dods_null_c:
				case dods_byte_c:
				case dods_int16_c:
				case dods_uint16_c:
				case dods_int32_c:
				case dods_uint32_c:
				case dods_float32_c:
				case dods_float64_c:
				case dods_str_c:
				case dods_url_c:
					{
						CString tval, tdt;
						GetDataInfo(pBT, tval, tdt, TRUE);
						if(value)
						{
							tquery = tquery + tval + ",";
						}
						else
						{
							dbname = dbname + lname + pBT->name().c_str() + " " +
									tdt + ",";
							list = list + lname + pBT->name().c_str() + ",";
						}
					}
					break;
				default:
					flag = FALSE;
					break;
			}
		}

		if(isSeqC)
		{
			lname = lname + pSeq->name().c_str() + ":";
			flag = TraverseSeq(pChild, query, lname, dbname, list, value);
		}
		else
		{
			int index;
			if(value)
			{
				index = tquery.ReverseFind(',');
				tquery.SetAt(index, ' ');
				tquery = tquery + ");";

				CDWizard *pParent = (CDWizard *)GetParent();
				try
				{
					pParent->m_DbCon.Execute((LPCTSTR)tquery);
				}
				catch(CDaoException e)
				{
					flag = FALSE;
					char buf[512];
					e.GetErrorMessage(buf, 512);
					MessageBox( buf,"Error:Could not Ingest Data!",MB_OK);
				}
			}
			else
			{
				index = dbname.ReverseFind(',');
				dbname.SetAt(index, ' ');
				index = list.ReverseFind(',');
				list.SetAt(index, ' ');
				valueflag = FALSE;
				flag = TRUE;  //just assuring....
			}
		}
		if(lname == ("") && value)
		{
			tdisp.Format("Ingesting into _DODS_%s Record: %d / %d",
						 pSeq->name().c_str(), count, nRow);
			m_TEPTextC.SetWindowText((LPCTSTR)tdisp);
			m_TEPTextC.SendMessage( WM_PAINT, 0, 0);
			m_PCIngestC.SetPos((count*100)/nRow);
		}
	}

	return flag;
}

BOOL CDPage2::OnKillActive() 
{
	// TODO: Add your specialized code here and/or call the base class

	CDWizard *pParent = (CDWizard *)GetParent();

	if(pParent->m_DCon)
	{
		delete (pParent->m_DCon);
	}
	if(pParent->m_das)
	{
		delete pParent->m_das;
	}
	if(pParent->m_dds)
	{
		delete pParent->m_dds;
	}

	return CPropertyPage::OnKillActive();
}
